% Run highway test.
function test_result = highwayrun(type,out_file)

if nargin == 1,
    out_file = [];
end;

% Choose examples.
if strcmp(type,'agg'),
    load Results/datagg128.mat;
    examples = {ex1agg,ex2agg,ex3agg,ex4agg,ex5agg,ex6agg,ex7agg,ex8agg,ex9agg,ex10agg,ex11agg,ex12agg,ex13agg,ex14agg,ex15agg,ex16agg};
    tests = {ex17agg,ex18agg,ex19agg,ex20agg};
elseif strcmp(type,'tgs'),
    load Results/datatgs128.mat;
    examples = {ex1tgs,ex2tgs,ex3tgs,ex4tgs,ex5tgs,ex6tgs,ex7tgs,ex8tgs,ex9tgs,ex10tgs,ex11tgs,ex12tgs,ex13tgs,ex14tgs,ex15tgs,ex16tgs};
    tests = {ex17tgs,ex18tgs,ex19tgs,ex20tgs};
elseif strcmp(type,'saf'),
    load Results/datasaf128.mat;
    examples = {ex1saf,ex2saf,ex3saf,ex4saf,ex5saf,ex6saf,ex7saf,ex8saf,ex9saf,ex10saf,ex11saf,ex12saf,ex13saf,ex14saf,ex15saf,ex16saf};
    tests = {ex17saf,ex18saf,ex19saf,ex20saf};
else
    error('Unknown example set requested!');
end;

addpaths;
test_result = runtest(...
    'gpirl',struct(...
        'ard_prior_wt',0,...
        'restarts',1,...
        'ame_init',1),...
    'highway',struct(...
        'seed',1,...
        'optimizes',0,...
        'fixed_pattern',1,...
        'carfile','Highway/cars128',...
        'group_lane_features',1,...
        'speed_features',0),...
    struct(...
        'training_sample_lengths',128,...
        'training_samples',1,...
        'user_examples',{examples},...
        'test_samples',1,...
        'user_tests',{tests},...
        'example_restarts',1,...
        'test_restarts',1,...
        'example_optimal',0,...
        'example_recompute_optimal',0,...
        'test_optimal',0,...
        'verbosity',4));
    
if ~isempty(out_file),
    save(out_file,'test_result');
end;
